package org.yaoqiang.bpmn.editor.dialog;

import org.yaoqiang.bpmn.editor.addon.Addon;
import org.yaoqiang.bpmn.model.elements.XMLExtensionElement;
import org.yaoqiang.dialog.Panel;
import org.yaoqiang.dialog.PanelContainer;

/**
 * BPMNPanelContainer
 * 
 * @author Shi Yaoqiang(shi_yaoqiang@yahoo.com)
 */
public class BPMNPanelContainer extends PanelContainer {

	private static final long serialVersionUID = 1L;

	protected static Addon currentAddon;
	
	public BPMNPanelContainer(BPMNElementDialog parentDialog) {
		super(parentDialog);
	}

	public void init() {
		panelFactory = new BPMNPanelFactory(this);
	}

	public void setActiveObject(Object el, String type) {
		setModified(false);
		Panel p = null;
		if (type != null && type.startsWith("addon") || el instanceof XMLExtensionElement) {
			BPMNPanelFactory panelFactory = getCurrentAddon().getPanelFactory(this);
			p = panelFactory.getPanel(el, type);
		} else {
			p = getPanelFactory().getPanel(el, type);
		}

		setViewPanel(p);
	}

	public Addon getCurrentAddon() {
		return currentAddon;
	}

	public void setCurrentAddon(Addon currentAddon) {
		BPMNPanelContainer.currentAddon = currentAddon;
	}

	public BPMNElementDialog getParentDialog() {
		return (BPMNElementDialog) parentDialog;
	}

	public BPMNPanelFactory getPanelFactory() {
		return (BPMNPanelFactory) panelFactory;
	}

}
