package org.yaoqiang.bpmn.model.elements.core.infrastructure;

import org.yaoqiang.bpmn.model.elements.XMLCollection;
import org.yaoqiang.bpmn.model.elements.XMLElement;

/**
 * Imports
 * 
 * @author Shi Yaoqiang(shi_yaoqiang@yahoo.com)
 */
public class Imports extends XMLCollection {

	private static final long serialVersionUID = 6145917051239297281L;

	public Imports(Definitions parent) {
		super(parent, "imports");
	}

	public XMLElement generateNewElement() {
		return new Import(this);
	}

	public String getElementName() {
		return "import";
	}
	
	public Definitions getParent() {
		return (Definitions) parent;
	}

	public void add(XMLElement el) {
		if (el == null) {
			return;
		}
		elements.put(((Import) el).getLocation(), el);
		el.setParent(this);
	}

	public XMLElement getCollectionElement(String location) {
		for (XMLElement ce : elements.values()) {
			if (((Import) ce).getLocation().equals(location)) {
				return ce;
			}
		}
		return null;
	}
}
