package org.yaoqiang.util;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Properties;

/**
 * SettingsManager
 * 
 * @author Shi Yaoqiang(shi_yaoqiang@yahoo.com)
 */
public class SettingsManager {

	private static Settings settings;

	private SettingsManager() {
	}

	public static Settings getSettings() {
		if (settings != null) {
			return settings;
		}

		Properties props = new Properties();
		try {
			props.load(new FileInputStream(getSettingsFile()));
		} catch (IOException e) {
		}
		settings = new Settings(props);

		return settings;
	}

	public static void saveSettings() {
		Properties props = settings.getProperties();
		try {
			props.store(new FileOutputStream(getSettingsFile()), "Yaoqiang BPMN Editor Configuration");
		} catch (IOException e) {
		}
	}

	private static File getSettingsFile() {
		return new File(Constants.YAOQIANG_USER_HOME + File.separator + Constants.YAOQIANG_CONF_FILE);
	}

}
